﻿uses 'toolbox.pas';

procedure log(s:string);
var
  dt:TDateTime;
begin
  dt:=Now;
  SQLExecute('insert into log(text) values ('''+DateToStr(dt)+' '+TimeToStr(dt)+' : '+SQLStr(s)+''')');
end;

function extract(s:string;f:string;t:string;var e:integer):string;
var
  b,c,l:integer;
begin
  b:=PosEx(f,s,e);
  l:=Length(f);
  c:=PosEx(t,s,b+l);
  if (b>0) and (c>0) then
  begin
    Result:=Copy(s,b+l,c-b-l);
    e:=c+Length(t);
  end
  else
  begin
    Result:='';
  end;
end;

function DecodeUTF8(const s:string):string;
var
  c0,c1,c2,c3,c,i,n,m,p:Integer;
  o0,o1,o2:Integer;
  b1,b2,b3:Boolean;
begin
  Result:='';

  if (Ord(s[p]) and 255)=0 then
  begin
    i:=2;
  end
  else
  begin
    i:=1;
  end;

  n:=Length(s);
  while i<=n do
  begin
    p:=i shr 1;
    m:=i and 1;

    o0:=Ord(s[p]);
    o1:=Ord(s[p+1]);
    if m=0 then
    begin
      c0:=o0 and 255;
      c1:=o0 shr 8;
      c2:=o1 and 255;
      c3:=o1 shr 8;
    end
    else
    begin
      o2:=Ord(s[p+2]);
      c0:=o0 shr 8;
      c1:=o1 and 255;
      c2:=o1 shr 8;
      c3:=o2 and 255;
    end;
    b1:=c1>=128;
    b2:=c2>=128;
    b3:=c3>=128;

    if (c0>=240) and b1 and b2 and b3 then
    begin
      c:=(((c0 and 15) shl 6) or ((c1 and 127)) shr 12) or ((c2 and 127) shl 6) or (c3 and 127);
      inc(i,4);
    end
    else
    begin
      if (c0>=224) and b1 and b2 then
      begin
        c:=((c0 and 31) shr 12) or ((c1 and 127) shl 6) or (c2 and 127);
        inc(i,3);
      end
      else
      begin
        if (c0>=192) and b1 then
        begin
          c:=((c0 and 63) shl 6) or (c1 and 127);
          inc(i,2);
        end
        else
        begin
          c:=c0 and 127;
          inc(i);
        end;
      end;
    end;
    Result:=Result+Chr(c);
  end;
end;

function LoadFromFileUTF8(FileName: string):string;
var
  l:integer;
  s:string;
  fs:TFileStream;
begin
  l:=GetFileSize(FileName);
  if l>0 then
  begin
    fs:=TFileStream.Create(FileName,fmOpenRead );
    fs.Position := 0;
    SetLength(s,l);
    fs.Read(s, l);
    fs.Free;
    Result:=DecodeUTF8(s);
  end
  else
    Result:='';
end;

function LoadFromFile(FileName: string):string;
var
  c,l,m:integer;
  s:string;
  fs:TFileStream;
begin
  Result:='';
  l:=GetFileSize(FileName);
  if l>0 then
  begin
    if FileExists(FileName+'.out') then DeleteFile(FileName+'.out');
    OpenFile(FileName+' '+FileName+'.out','toUnicode.exe');
    c:=5;
    m:=GetFileSize(FileName+'.out');
    repeat
      sleep(500);
      l:=GetFileSize(FileName+'.out');
      if l>0 then
      begin
        if l=m then break;
        m:=l;
      end
      else
      begin
        dec(c);
      end;
    until c=0;
    if l>0 then
    begin
      fs:=TFileStream.Create(FileName+'.out',fmOpenRead );
      fs.Position := 0;
      SetLength(s,l);
      fs.Read(s, l);
      fs.Free;
      Result:=s;
      DeleteFile(FileName+'.out');
    end;
  end;
end;

procedure Form1_ButtonXmlUrl_OnClick (Sender: string; var Cancel: boolean);
var
  sl:TStringList;
  r,s:string;
  i,c,e,f:integer;

  title,description,url:string;
  description_utf:string;

begin
  log('HTTPGetFile');
  HTTPGetFile(Form1.EditXmlUrl.Text,'rss.xml',false);

  if FileExists('rss.xml') then
  begin
    SQLExecute('delete from import');
    e:=1;
    log('LoadFromFileUTF8');
    //s:=LoadFromFileUTF8('rss.xml');
    s:=LoadFromFile('rss.xml');
    log('Extract');
    repeat
      r:=extract(s,'<item>','</item>',e);
      if (r<>'') then
      begin
        f:=1;
        title:=extract(r,'<title>','</title>',f);
        description:=extract(r,'<description>','</description>',f);
        url:=extract(r,'<enclosure url="','" length="',f);
        SQLExecute('insert into import(title,url,description) values ('''+SQLStr(title)+''','''+SQLStr(url)+''','''+SQLStr(description)+''')');
        s:=Copy(s,e,Length(s)-e+1);
        e:=1;
      end;
    until r='';
    log('Done');
  end;
end;

begin
  Form1.mniFile.Visible := False;
  Form1.mniOptions.Visible := False;
  Form1.mniSettings.Visible := False;
  Form1.mniReport.Visible := False;
  Form1.mniAbout.Visible := False;
end.

